=== debian/changelog ===
paho.mqtt.c (1.3.15-1) unstable; urgency=medium

  * New upstream version 1.3.15
  * debian/control: update Standards-Version to 4.7.2
  * debian/rules: build with UNIX socket support
  * debian/patches: Remove merged patch for GNU Hurd build
  * debian/copyright: update copyright information

 -- Roman Ondráček <mail@romanondracek.cz>  Mon, 18 Aug 2025 00:21:31 +0200
