=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPAHO_BUILD_SHARED=TRUE \
		-DPAHO_BUILD_STATIC=TRUE \
		-DPAHO_WITH_SSL=TRUE \
		-DPAHO_WITH_UNIX_SOCKETS=TRUE \
		-DPAHO_BUILD_SAMPLES=TRUE \
		-DPAHO_ENABLE_TESTING=FALSE \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_auto_install:
	dh_auto_install
