=== debian/control ===
--- 
+++ 
@@ -1,9 +1,7 @@
 Source: paho.mqtt.c
-Priority: optional
 Maintainer: Roman Ondráček <mail@romanondracek.cz>
-Build-Depends: debhelper (>= 12), debhelper-compat (= 13), cmake (>= 2.8.12), libssl-dev
-Rules-Requires-Root: no
-Standards-Version: 4.7.2
+Build-Depends: debhelper (>= 12), debhelper-compat (= 13), cmake (>= 3.12), libssl-dev
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://github.com/eclipse-paho/paho.mqtt.c/
 Vcs-Browser: https://salsa.debian.org/ondracek/paho.mqtt.c
