## paho.mqtt.c 1.3.16+ds

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #*******************************************************************************
-#  Copyright (c) 2015, 2024 logi.cals GmbH, Frank Pagliughi <fpagliughi@mindspring.com> and others
+#  Copyright (c) 2015, 2026 logi.cals GmbH, Frank Pagliughi <fpagliughi@mindspring.com> and others
 #
 #  All rights reserved. This program and the accompanying materials
 #  are made available under the terms of the Eclipse Public License v2.0
@@ -79,7 +79,7 @@
   elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
     set(LIBS_SYSTEM compat pthread)
   elseif(CMAKE_SYSTEM_NAME MATCHES "QNX")
-    set(LIBS_SYSTEM c)
+    set(LIBS_SYSTEM c socket)
   else()
     set(LIBS_SYSTEM c pthread)
   endif()
@@ -381,4 +381,3 @@
         PUBLIC
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
-        PRIVATE
