=== debian/changelog ===
paho.mqtt.c (1.3.16+ds-1) unstable; urgency=medium

  * debian/watch: update to version 5
  * debian/control: update Standards-Version to 4.7.3 and remove redundant rules
  * debian/copyright: exclude generated Doxygen documentation from source
    tarball
  * New upstream version 1.3.16+ds
  * debian/patches: remove marged patch
  * debian/control: update Build-Depends
  * debian/copyright: update copyright information
  * debian/source.lintian-overrides: ignore long lines in Travis CI YAML and
    EDLv1.0 license

 -- Roman Ondráček <mail@romanondracek.cz>  Sat, 21 Feb 2026 00:37:58 +0100
