=== debian/watch ===
Version: 5
Template: GitHub
Owner: eclipse-paho
Project: paho.mqtt.c
Pgp-mode: none
Dversion-Mangle: s/\+ds\d*$//
Repack-Suffix: +ds
